--[[
LuckyCharms2 r31
Last Changed By: neer
Last Changed: 2011-01-19T03:36:31Z

Changes: See changelog.txt
ReadMe: See readme.txt

###Known Bugs###
None
]]

--Globals
local LC2_Realm = GetCVar("realmName"); --Get Realm for Profile.
local LC2_Char = UnitName("player"); --Get char name for profile.
local LC2Profile = LC2_Realm.." - "..LC2_Char;
local LBF = LibStub("LibButtonFacade",true);

LuckyCharmsFlares = {};

function LuckyCharmsFlares_onLoad(self)
	self:RegisterEvent('ADDON_LOADED');
end

function LuckyCharmsFlares_onEvent(self,event,...)
	--LuckyCharms_msg(event.." Called!");--Debug
	if(event == "ADDON_LOADED") then
		local arg1 = ...;
		if(arg1 == LC2Name) then
			
			--Check for settings array.  Used for Profiles.
			if( not LC2_Settings ) then
				LC2_Settings = {};
			end
			--Check for Profile Settings
			if( not LC2_Settings[LC2Profile]) then
				LC2_Settings[LC2Profile] = {};
			end
			
			if(not LC2_Settings[LC2Profile].tooltips) then
				LC2_Settings[LC2Profile].tooltips=1; --Show Tooltips
			end
			
			--ButtonFacade Support
			if(not LBF) then
		  	--Set Frame Backdrop  Future BF support
				LuckyCharmsFlares_main:SetBackdrop({bgFile = "Interface\\DialogFrame\\UI-DialogBox-Background",
		  		edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border", tile=true,tileSize=10,edgeSize=16,
		  		insets = {left=4, right=4, top=4, bottom=4}
		  	});
			end
			--End ButtonFacade Support
			
			LuckyCharms2Flares_AddButtons();
			LuckyCharmsFlares.SetTexCoords();
		end
	end
end

function LuckyCharms2Flares_AddButtons()
	for i=1,6 do
		local b = _G["LuckyCharm2Flare"..i];
		if(not b) then
			if(i~=6)then
				b = CreateFrame("Button","LuckyCharm2Flare"..i,LuckyCharmsFlares_main,"LC2_FlareBtnVirtual");
				if(i==1)then
					b:SetPoint("TOPLEFT", LuckyCharmsFlares_main, "TOPLEFT",5,-5);
				else
					b:SetPoint("LEFT", _G["LuckyCharm2Flare"..i-1], "RIGHT",0,0);
				end
				b:SetAttribute("type", "macro");
				b:SetAttribute("macrotext1", "/click CompactRaidFrameManagerDisplayFrameLeaderOptionsRaidWorldMarkerButton\n/click DropDownList1Button"..i);
				b:SetScript("OnEnter", function(self) if (LC2_Settings[LC2Profile].tooltips == 1) then GameTooltip:SetOwner(self, "ANCHOR_CURSOR"); GameTooltip:ClearLines(); GameTooltip:AddLine(_G["WORLD_MARKER"..i],0.88,0.65,0); GameTooltip:Show() end end);
				b:SetScript("OnLeave", function(self) GameTooltip:Hide() end);
	
				local t = _G["LuckyCharm2Flare"..i.."Icon"];
				t:SetTexture("interface\\minimap\\partyraidblips");
			else
				--Clear Flares
				b = CreateFrame("Button","LuckyCharm2Flare"..i,LuckyCharmsFlares_main,"LC2_FlareBtnVirtual");
				b:SetPoint("LEFT", _G["LuckyCharm2Flare"..i-1], "RIGHT",0,0);
				b:SetAttribute("type", "macro")
				b:SetAttribute("macrotext1", "/click CompactRaidFrameManagerDisplayFrameLeaderOptionsRaidWorldMarkerButton\n/click DropDownList1Button6")
				b:SetScript("OnEnter", function(self) if (LC2_Settings[LC2Profile].tooltips == 1) then GameTooltip:SetOwner(self, "ANCHOR_CURSOR"); GameTooltip:ClearLines(); GameTooltip:AddLine(LC2FTT_LeftClick.." "..REMOVE_WORLD_MARKERS,0.88,0.65,0); GameTooltip:AddLine(LC2FTT_RightClick,0.88,0.65,0);GameTooltip:Show() end end)
				b:SetScript("OnLeave", function(self) GameTooltip:Hide() end)
				b:SetScript("OnMouseDown", function(self,button) if (button=="RightButton") then LuckyCharmsFlares_main:StartMoving() end end)
				b:SetScript("OnMouseUp", function(self) LuckyCharmsFlares_main:StopMovingOrSizing() end)
	
				local t = _G["LuckyCharm2Flare"..i.."Icon"];
				t:SetTexture("Interface\\BUTTONS\\UI-GroupLoot-Pass-Up");
			end
		end
	end
end

function LuckyCharmsFlares.SetTexCoords()
	for i=1,5 do
		local f = _G["LuckyCharm2Flare"..i.."Icon"];
		if(f)then
			if(i==1)then
				f:SetTexCoord(0.75,0.875,0,0.25);--Blue Flare
			elseif(i==2)then
				f:SetTexCoord(0.25,0.375,0,0.25);--Green Flare
			elseif(i==3)then
				f:SetTexCoord(0,0.125,0.25,0.5);--Purple Flare
			elseif(i==4)then
				f:SetTexCoord(0.625,0.75,0,0.25);--Red Flare
			elseif(i==5)then
				f:SetTexCoord(0.375,0.5,0,0.25);--Yellow Flare
			end
		end
	end
end